# JOSH - Javascript Object Storage Helper

<div align="center">
  <p>
    <a href="https://discord.gg/N7ZKH3P"><img src="https://discordapp.com/api/guilds/298508738623438848/embed.png" alt="Discord server" /></a>
    <a href="https://www.npmjs.com/package/josh"><img src="https://img.shields.io/npm/v/josh.svg?maxAge=3600" alt="NPM version" /></a>
    <a href="https://www.npmjs.com/package/josh"><img src="https://img.shields.io/npm/dt/josh.svg?maxAge=3600" alt="NPM downloads" /></a>
    <a href="https://david-dm.org/eslachance/josh"><img src="https://img.shields.io/david/eslachance/josh.svg?maxAge=3600" alt="Dependencies" /></a>
    <a href="https://www.patreon.com/eviecodes"><img src="https://img.shields.io/badge/donate-patreon-F96854.svg" alt="Patreon" /></a>
  </p>
  <p>
    <a href="https://nodei.co/npm/josh/"><img src="https://nodei.co/npm/josh.png?downloads=true&stars=true" alt="npm installnfo" /></a>
  </p>
</div>

<div align="center">
  <p><img src="https://evie.codes/josh-light.png" alt="Josh Logo" />
</div>

JOSH is the JavaScript Object Storage Helper - a simple, effective, and efficient database wrapper.

![Under Construction - I've always wanted to use this image seriously!](https://upload.wikimedia.org/wikipedia/en/4/4f/Under_construction.JPG)

## Documentation

 * [Installation](https://josh.evie.dev/install)
 * [Basic Setup](https://josh.evie.dev/usage)
 * [API Reference](https://josh.evie.dev/api)
 * [Examples](https://josh.evie.dev/examples)

## Support

Support is offered on my official [Evie.Codes Discord](https://discord.gg/N7ZKH3P).

### FAQs

## Who the hell is Josh?

I'm sure you meant *What* the hell is Josh, and it's quite simply the easiest data storage system you'll ever encounter. Josh will help you
store any JSON-based data simply, effectively, into any popuplar database back-end.

* Josh is trustworhty: He's never lost a single bit yet, and not about to start.
* Josh is dependable: As long as your database doesn't fail, Josh won't fail.
* Josh is speedy: He has a minimal footprint, walks around light a balerina, silent as a mouse.
* Josh cares about you: He's friendly, knows his stuff, is documented well, and won't leave you in the dark.

### Why use Josh?

The best reason to use Josh is quite simply to get a project up and running as quickly as possible with as little effort as possible when it
comes to the database interaction layer.  It does this by removing the complexity of setting up an ORM or learning a database language, while
still giving you all the power it can muster.

### When NOT to use Josh?

If you think you can do better, if you already know database interactions or ORMs, or you don't trust database wrappers made by other people...
well in any of those cases I don't even know why you're on this page, go on now, `git out --of:here` and go make some good apps, you don't need this!

### When's he coming to town?

Josh is right around the corner, lurking around. It's in Early Access right now, with very limited functionality, but if you want to start testing it out, please, by all means, [Go take a look at the documentation](https://josh.evie.dev/) and try it!